import ts from 'typescript';
import { TypeDeclaration } from './utils';
export declare class Parser {
    private sourceFiles;
    private getRelativePath;
    private checker?;
    private declarations;
    disableWarning: boolean;
    constructor(sourceFiles: ts.SourceFile[], getRelativePath: (fileName: string) => string, checker?: ts.TypeChecker | undefined);
    parse(): TypeDeclaration[];
    private preHandleEnumDeclaration;
    private handleEnumDeclarationInitializer;
    private handleSourceFile;
    private handleFunctionDeclaration;
    private handleFunctionParameter;
    private handleInterfaceOrClassDeclaration;
    private handleHeritageClauses;
    private handleExpressionWithTypeArguments;
    private handleTypeAliasDeclaration;
    private handleTypeLiteralOrUnionTypeOrIntersectionType;
    private handleUnionTypeOfLiteralType;
    private handleArrayTypeInTypeAliasDeclaration;
    private getJsDocs;
    private getType;
    private getTemplateSpans;
    private getTemplateLiteralTypeEnums;
    private getTemplateLiteral;
    private getEnumOfLiteralType;
    private getTypeOfLiteralType;
    private getTypeOfUnionTypeOrIntersectionType;
    private getTypeOfArrayTypeReference;
    private getTypeOfTypeReference;
    private getTypeOfTsType;
    private getTypeOfPick;
    private getTypeOfComplexType;
    private getTypeOfTypeLiteral;
    private getDecorators;
    private getMembersInfo;
    private getMembersInfoOfUnionType;
    private setOptionalAndEnumOfUnionType;
    private setEnumOfUnionType;
    private getMembersInfoOfIntersectionType;
    private getMembersInfoOfParenthesizedType;
    private getMembersInfoOfTypeReference;
    private preHandleType;
    private getObjectMembers;
    private getExpression;
    private getTypeAndValueOfExpression;
    private getObjectMemberOfPropertyOrMethodOrConstructorParameterOrCallSignature;
    private getParameter;
    private setJsDoc;
    private setPropertyJsDoc;
    private setJsDocReference;
    private setJsDocTag;
    private setJsDocMapValue;
    private setJsDocParam;
    private setJsDocBoolean;
    private setJsDocEnum;
    private getJsDocComment;
    private setJsDocString;
    private setJsDocNumber;
    private overrideType;
    private setJsDocArray;
    private setJsDocNumberArray;
    private setJsDocStringArray;
    private setJsDocObject;
    private getPosition;
    private getModifiers;
}
