import { TypeDeclaration, Type, FunctionDeclaration, FunctionParameter, EnumDeclaration, EnumMember, ObjectDeclaration, UnionDeclaration, StringDeclaration, ReferenceDeclaration, NumberDeclaration } from './utils';
/**
 * @public
 */
export declare function generateTypescript(declarations: TypeDeclaration[]): string;
/**
 * @public
 */
export declare function generateTypescriptOfReferenceDeclaration(declaration: ReferenceDeclaration): string;
/**
 * @public
 */
export declare function generateTypescriptOfStringOrNumberDeclaration(declaration: StringDeclaration | NumberDeclaration): string;
/**
 * @public
 */
export declare function generateTypescriptOfUnionDeclaration(declaration: UnionDeclaration): string;
/**
 * @public
 */
export declare function generateTypescriptOfObjectDeclaration(declaration: ObjectDeclaration): string;
/**
 * @public
 */
export declare function generateTypescriptOfObjectAdditionalProperties(additionalProperties: true | Type): string;
/**
 * @public
 */
export declare function generateTypescriptOfEnumDeclaration(declaration: EnumDeclaration): string;
/**
 * @public
 */
export declare function generateTypescriptOfEnumMember(member: EnumMember): string;
/**
 * @public
 */
export declare function generateTypescriptOfFunctionDeclaration(declaration: FunctionDeclaration): string;
/**
 * @public
 */
export declare function generateTypescriptOfFunctionParameter(parameter: FunctionParameter, processChild?: (type: Type) => string | undefined): string;
/**
 * @public
 */
export declare function generateTypescriptOfType(type: Type, processChild?: (type: Type) => string | undefined): string;
